All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
AmoebaOutOfPlaneBendForce Class Reference

This class implements the Amoeba out-of-plane bend interaction. More...

`#include <AmoebaOutOfPlaneBendForce.h>`

Inheritance diagram for AmoebaOutOfPlaneBendForce:

## Public Member Functions

| AmoebaOutOfPlaneBendForce ()
| Create an AmoebaOutOfPlaneBendForce. More...
int | getNumOutOfPlaneBends () const
| Get the number of out-of-plane bend terms in the potential function. More...
void | setAmoebaGlobalOutOfPlaneBendCubic (double cubicK)
| Set the global cubic term. More...
double | getAmoebaGlobalOutOfPlaneBendCubic (void) const
| Get the global cubic term. More...
void | setAmoebaGlobalOutOfPlaneBendQuartic (double quarticK)
| Set the global cubic term. More...
double | getAmoebaGlobalOutOfPlaneBendQuartic (void) const
| Get the global quartic term. More...
void | setAmoebaGlobalOutOfPlaneBendPentic (double penticK)
| Set the global pentic term. More...
double | getAmoebaGlobalOutOfPlaneBendPentic (void) const
| Get the global pentic term. More...
void | setAmoebaGlobalOutOfPlaneBendSextic (double sexticK)
| Set the global sextic term. More...
double | getAmoebaGlobalOutOfPlaneBendSextic (void) const
| Get the global sextic term. More...
int | addOutOfPlaneBend (int particle1, int particle2, int particle3, int particle4, double k)
| Add an out-of-plane bend term to the force field. More...
void | getOutOfPlaneBendParameters (int index, int &particle1, int &particle2, int &particle3, int &particle4, double &k) const
| Get the force field parameters for an out-of-plane bend term. More...
void | setOutOfPlaneBendParameters (int index, int particle1, int particle2, int particle3, int particle4, double k)
| Set the force field parameters for an out-of-plane bend term. More...
void | updateParametersInContext (Context &context)
| Update the per-bend term parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Protected Attributes

double | _globalCubicK
double | _globalQuarticK
double | _globalPenticK
double | _globalSexticK

## Detailed Description

This class implements the Amoeba out-of-plane bend interaction.

To use it, create an OutOfPlaneBendForce object then call addOutOfPlaneBend() once for each outOfPlaneBend. After an out-of-plane bend has been added, you can modify its force field parameters by calling setOutOfPlaneBendParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaOutOfPlaneBendForce | ( |  | ) |

Create an AmoebaOutOfPlaneBendForce.

## Member Function Documentation

int addOutOfPlaneBend | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | double | k
| ) |  |

Add an out-of-plane bend term to the force field.

Parameters

  particle1 | the index of the first particle connected by the outOfPlaneBend
  particle2 | the index of the second particle connected by the outOfPlaneBend
  particle3 | the index of the third particle connected by the outOfPlaneBend
  particle4 | the index of the fourth particle connected by the outOfPlaneBend
  k | the force constant for the out-of-plane bend

Returns
  the index of the out-of-plane bend that was added

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getAmoebaGlobalOutOfPlaneBendCubic | ( | void |  | ) | const

Get the global cubic term.

Returns
  global cubicK term

double getAmoebaGlobalOutOfPlaneBendPentic | ( | void |  | ) | const

Get the global pentic term.

Returns
  global penticK term

double getAmoebaGlobalOutOfPlaneBendQuartic | ( | void |  | ) | const

Get the global quartic term.

Returns
  global quartic term

double getAmoebaGlobalOutOfPlaneBendSextic | ( | void |  | ) | const

Get the global sextic term.

Returns
  global sexticK term

int getNumOutOfPlaneBends | ( |  | ) | const

inline

Get the number of out-of-plane bend terms in the potential function.

void getOutOfPlaneBendParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | int & | particle4,
|  | double & | k
| ) |  | const

Get the force field parameters for an out-of-plane bend term.

Parameters

  index | the index of the outOfPlaneBend for which to get parameters
  particle1 | the index of the first particle connected by the outOfPlaneBend
  particle2 | the index of the second particle connected by the outOfPlaneBend
  particle3 | the index of the third particle connected by the outOfPlaneBend
  particle4 | the index of the fourth particle connected by the outOfPlaneBend
  k | the force constant for the out-of-plane bend

void setAmoebaGlobalOutOfPlaneBendCubic | ( | double | cubicK | ) |

Set the global cubic term.

Parameters

  cubicK | the cubic force constant for the angle

void setAmoebaGlobalOutOfPlaneBendPentic | ( | double | penticK | ) |

Set the global pentic term.

Parameters

  penticK | the pentic force constant for the angle

void setAmoebaGlobalOutOfPlaneBendQuartic | ( | double | quarticK | ) |

Set the global cubic term.

Parameters

  quarticK | the quartic force constant for the angle

void setAmoebaGlobalOutOfPlaneBendSextic | ( | double | sexticK | ) |

Set the global sextic term.

Parameters

  sexticK | the sextic force constant for the angle

void setOutOfPlaneBendParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | double | k
| ) |  |

Set the force field parameters for an out-of-plane bend term.

Parameters

  index | the index of the outOfPlaneBend for which to set parameters
  particle1 | the index of the first particle connected by the outOfPlaneBend
  particle2 | the index of the second particle connected by the outOfPlaneBend
  particle3 | the index of the third particle connected by the outOfPlaneBend
  particle4 | the index of the fourth particle connected by the outOfPlaneBend
  k | the force constant for the out-of-plane bend

void updateParametersInContext | ( | Context & | context | ) |

Update the per-bend term parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setOutOfPlaneBendParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information this method updates is the values of per-bend term parameters. The set of particles involved in a term cannot be changed, nor can new terms be added.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if nonbondedMethod uses PBC and false otherwise

Reimplemented from Force.

## Member Data Documentation

double _globalCubicK

protected

double _globalPenticK

protected

double _globalQuarticK

protected

double _globalSexticK

protected

The documentation for this class was generated from the following file:

- AmoebaOutOfPlaneBendForce.h